// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

// Copyright 2003 Liam Girdwood  

#include "nebula.hh"
#include <libnova.h>

namespace Castor
{

Nebula::Nebula()
{
}

Nebula::~Nebula()
{
}

double Nebula::get_disk (double JD)
{
	return get_solar_sdiam(JD);
}
	
/*! \fn void Nebula::get_equ_posn (double JD, ln_equ_posn* posn)
* \brief Get object equatorial position.
*/
void Nebula::get_equ_posn (double& ra, double& dec, double JD)
{
}

/*! \fn void Nebula::get_hrz_posn (double JD, ln_lnlat_posn* observer, ln_hrz_posn* posn)
* \brief Get object horizontal position
*/
void Nebula::get_hrz_posn (double JD, ln_lnlat_posn* observer, ln_hrz_posn* posn)
{
	struct ln_equ_posn equ_posn;
		
	get_equ_solar_coords(JD, &equ_posn);
	get_hrz_from_equ (&equ_posn, observer, JD, posn);
}

/*! \fn void Nebula::get_rst_time (double JD, ln_lnlat_posn* observer, ln_rst_time* time)
* \brief Get object rise, transit and set time.
*/
void Nebula::get_rst_time (double JD, ln_lnlat_posn* observer, ln_rst_time* time)
{
	get_solar_rst(JD, observer, time);
}

/*! \fn double Nebula::get_ra()
* \brief Get object Right Ascension
*/
void Nebula::get_posn(double& ra, double& dec)
{
	//get_solar_posn (JD, ra, dec);
}

/*! \fn double Nebula::get_mag()
* \brief Get object Magnitude
*/
double Nebula::get_mag()
{
}
		
/*! \fn void Nebula::get_id(std::string& id)
* \brief Get object identification number.
*/
void Nebula::get_id(std::string& id)
{
}	

/*! \fn void Nebula::get_name(std::string& name)
* \brief Get object name.
*/
void Nebula::get_name(std::string& name)
{
}

/*! \fn void Nebula::get_info (std::list<Glib::ustring>& value)
* \brief Get object information
*/
void Nebula::get_info (std::list<Glib::ustring>& value)
{
}

/*! \fn void Nebula::render(double x, double y, double mag_max, Gnome::Canvas::Group& group)
* \brief Render object
*/
void Nebula::render(double x, double y, double mag_max, Gnome::Canvas::Group& group, bool bright)
{
}

}
