// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

// Copyright 2003 Liam Girdwood  

#ifndef _CASTOR_SKYMAP_OBJECT_HH
#define _CASTOR_SKYMAP_OBJECT_HH

#include "star_object.hh"

namespace Castor
{
	
class SkymapObject : public StarObject
{
	public:
		SkymapObject();
		~SkymapObject();
	
		bool add_element (std::string& name, element_type type,
									std::string& value);
		bool check_element (std::string& name);
	
		int save (std::ofstream* file);
		int load (std::ifstream* file);
	
		/*! \fn void get_info (std::list<Glib::ustring> name,  std::list<Glib::ustring> value);
		* \brief Get object information
		*/
		void get_info (std::list<Glib::ustring>& name,  std::list<Glib::ustring>& value);
	
	protected:
		double m_rv;
		std::string m_sp_mk;
};

};

#endif
