// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

// Copyright 2003 Liam Girdwood  

#include "file.hh"

namespace GUI
{

NovaFile::NovaFile()
{
	set_callbacks(); 
}

NovaFile::NovaFile(Glib::ustring title) : Gtk::FileSelection(title)
{
	set_callbacks();
}

NovaFile::~NovaFile()
{
}

void NovaFile::set_callbacks()
{
	// Connect the ok_button_ to file_ok_sel function 
    get_ok_button()->signal_clicked().connect(slot(*this, &NovaFile::ok_clicked));
	
    // Connect the cancel_button_ to hiding the window 
    get_cancel_button()->signal_clicked().connect(SigC::slot(*this, &NovaFile::cancel_clicked));
}

void NovaFile::ok_clicked()
{
	hide();
	response(Gtk::RESPONSE_OK); //stops run().
}

void NovaFile::cancel_clicked()
{
	hide();
	response(Gtk::RESPONSE_CANCEL); //stops run().
}

}
