// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

// Copyright 2003 Liam Girdwood  

#ifndef __FILE_HH
#define __FILE_HH

#include "config.h"
#include <gtkmm/fileselection.h>

namespace GUI
{

/*! \class NovaFile
* \brief File selection
*
* The Nova file selector
*/
class NovaFile : public Gtk::FileSelection
{
	public:
		/*! \fn NovaFile
		* \brief Constructor
		*/
		NovaFile();
	
		/*! \fn NovaFile
		* \brief Constructor with title
		*/
		NovaFile(Glib::ustring title);
	
		/*! \fn NovaFile
		* \brief Destructor
		*/
		virtual ~NovaFile();
	
	private:
		void ok_clicked();
		void cancel_clicked();
		void set_callbacks();
	
};

}

#endif
